/*
 * main.cpp
 *
 *  Created on: Nov 13, 2014
 *      Author: marco
 */

#include <gecode/driver.hh>
#include <gecode/int.hh>
#include <gecode/minimodel.hh>

#include <algorithm>
#include <iomanip>

#include "Input.h"



using namespace Gecode;

class ExamPlan: public Script {
protected:
	Input *p_in;
	int n;
	IntVarArray X;
public:
	/// Setup model
  ExamPlan(const InstanceOptions& opt, Input *in) : Script(opt), p_in(in), n(in->getNCourses()) {
  // YOUR CODE HERE
          
          // if branch is missing then values not assigned
	}
	/// Constructor for cloning \a s
	ExamPlan(bool share, ExamPlan& s) :
			Script(share, s) {
          // YOUR CODE HERE
	}
	;
	/// Copy during cloning
	virtual Space* copy(bool share) {
          return new ExamPlan(share, *this);
	}
	;
	/// Print solution
	virtual void print(std::ostream& os) const {
          //YOUR CODE HERE
	}
	;
};

int main(int argc, char* argv[]) {

	InstanceOptions opt("ExamPlan");
	opt.instance("./");
	// better to have the followinmg in development phase
	// this does not work with e.next
	opt.solutions(1);
	opt.iterations(20);
	opt.fail(20);
	opt.time(6000);

	opt.parse(argc, argv);

	Input *p = new Input(opt.instance());
	cout << *p;

	ExamPlan* m = new ExamPlan(opt, p);
	SpaceStatus status = m->status();
	if (status == SS_FAILED)
		cout << "Status: " << m->status() << " the space is failed at root." << endl;
	else if (status == SS_SOLVED)
		cout << "Status: " << m->status()
				<< " the space is not failed but the space has no brancher left." << endl;
	else if (status == SS_BRANCH)
		cout << "Status: " << m->status() << " the space is not failed and we need to start branching."
				<< endl;
	m->print(cout);
//Script::run<*m, DFS, Options>(opt);
	DFS<ExamPlan> e(m); //Options>(opt);
	while (ExamPlan* s = e.next()) {
		s->print(cout);
		delete s;
	}
	delete m;
	delete p;
	return 0;
}

